Fix custom images support
[snf-image] / snf-image-host / create
1 #!/bin/bash
2
3 # Copyright 2011 GRNET S.A. All rights reserved.
4 #
5 # Redistribution and use in source and binary forms, with or without
6 # modification, are permitted provided that the following conditions
7 # are met:
8 #
9 #   1. Redistributions of source code must retain the above copyright
10 #      notice, this list of conditions and the following disclaimer.
11 #
12 #  2. Redistributions in binary form must reproduce the above copyright
13 #     notice, this list of conditions and the following disclaimer in the
14 #     documentation and/or other materials provided with the distribution.
15 #
16 # THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
17 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18 # IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
19 # ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
20 # FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
21 # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
22 # OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
23 # HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
24 # LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
25 # OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
26 # SUCH DAMAGE.
27 #
28 # The views and conclusions contained in the software and documentation are
29 # those of the authors and should not be interpreted as representing official
30 # policies, either expressed or implied, of GRNET S.A.
31
32 set -e
33 set -o pipefail
34
35 . common.sh
36
37 ganeti_os_main
38
39 if [ "$IMAGE_TYPE" = custom ]; then
40     image_file=/dev/null
41     image_size=\
42         $("$CURL" -sI "$IMAGE_NAME" | grep ^Content-Length: | cut -d" " -f2)
43 else
44     image_file="$IMAGE_DIR/$IMAGE_NAME-$ARCH.$IMAGE_TYPE"
45     image_size="$(stat -L -c %s "$image_file")"
46 fi
47
48 if [ ! -e "$image_file" ]; then
49     log_error "Image file \`$image_file' does not exit."
50     exit 1
51 fi
52
53 monitor="" #Empty if progress monitor support is disabled
54 if [ "$progress_monitor_support" = "yes" ]; then
55     monitor="$(printf "%q" "$PROGRESS_MONITOR") \
56         -i $(printf "%q" "$INSTANCE_NAME") -r $image_size"
57 fi
58
59 # If the target device is not a real block device we'll first losetup it.
60 # This is needed for file disks.
61 if [ ! -b "$blockdev" ]; then
62     original_blockdev="$blockdev"
63     blockdev=$("$LOSETUP" -sf "$blockdev")
64     add_cleanup "$LOSETUP" -d "$blockdev"
65 fi
66
67 case "$IMAGE_TYPE" in
68     ntfsdump|extdump)
69         # Create partitions
70         format_disk0 "$blockdev" "$IMAGE_TYPE"
71
72         # Install a new MBR
73         "$INSTALL_MBR" -p 1 -i n "$blockdev"
74
75         target="$(map_disk0 "$blockdev")-1" #the root device
76         add_cleanup unmap_disk0 "$blockdev"
77         snf_export_ROOT=1
78         ;;
79     diskdump|custom)
80         target="$blockdev"
81         ;;
82 esac
83
84 if [ "$IMAGE_TYPE" = "custom" ]; then
85     "$WGET" -O - $IMAGE_NAME | $monitor dd bs=4M of="$target" oflag=direct
86 else
87     # dd the dump to its new home :-)
88     # Deploying an image file on a target block device is a streaming copy
89     # operation. Enable the direct I/O flag on the output fd to avoid polluting
90     # the host cache with useless data.
91     $monitor dd bs=4M if="$image_file" of="$target" oflag=direct
92 fi
93
94 # Create a floppy image
95 floppy=$(mktemp --tmpdir floppy.XXXXXX)
96 add_cleanup rm "$floppy"
97
98 snf_export_DEV=/dev/vda
99 snf_export_TYPE="$IMG_FORMAT"
100 snf_export_PASSWORD="$IMG_PASSWD"
101 snf_export_HOSTNAME="$instance"
102 snf_export_PROPERTIES="$IMG_PROPERTIES"
103 if [ -n "$IMG_PERSONALITY" ]; then
104     snf_export_PERSONALITY="$IMG_PERSONALITY"
105 fi
106
107 create_floppy "$floppy"
108
109 # Invoke the helper vm to do the dirty job...
110 result_file=$(mktemp --tmpdir result.XXXXXX)
111 add_cleanup rm "$result_file"
112
113 snapshot=$(mktemp --tmpdir helperXXXXXX.img)
114 add_cleanup rm "$snapshot"
115
116 "$QEMU_IMG" create -f qcow2 -b "$HELPER_IMG" "$snapshot"
117
118 echo "$(date +%Y:%m:%d-%H:%M:%S.%N) Starting helper VM..."
119 "$TIMELIMIT" -t "$HELPER_SOFT_TIMEOUT" -T "$HELPER_HARD_TIMEOUT" \
120     kvm -runas "$HELPER_USER" -drive file="$snapshot" \
121     -drive file="$blockdev",format=raw,if=virtio,cache=none \
122     -boot c -serial stdio -serial file:"$result_file" \
123     -fda "$floppy" -vga none -nographic -parallel none -monitor null \
124     -kernel "$HELPER_KERNEL" -initrd "$HELPER_INITRD" \
125     -append "quiet ro root=/dev/sda1 console=ttyS0,9600n8 snf_image_activate_helper" \
126     2>&1 | sed 's|^|HELPER: |g'
127 echo "$(date +%Y:%m:%d-%H:%M:%S.%N) Helper VM finished."
128
129 if [ $? -ne 0 ]; then
130     if [ $? -gt 128 ];  then
131         log_error "Helper was terminated. Did not finish on time."
132     fi
133     exit 1
134 fi
135
136 # Read the first line. This will remove \r and \n chars
137 result=$(sed 's|\r||g' "$result_file" | head -1)
138
139 if [ "x$result" != "xSUCCESS" ]; then
140     log_error "Helper VM returned error"
141     exit 1
142 fi
143
144 # Execute cleanups
145 cleanup
146 trap - EXIT
147
148 exit 0
149
150 # vim: set sta sts=4 shiftwidth=4 sw=4 et ai :